#ifndef BEZIER_H
#define BEZIER_H

#include <GL/glew.h>

// A single control point of a Bezier curve
typedef struct control_point
{
    double x;
    double y;
}
control_point;

void    evaluate_bezier_curve(double *x, double *y, control_point p[], int num_points, double u);
void    draw_bezier_curve(int num_segments, control_point p[], int num_points);
int     intersect_cubic_bezier_curve(double *y, control_point p[], double x);

#endif
